// 002 u_c_shapes
// 28 feb 2009

// -- (C) John COLIBRI 2009
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_c_shapes;
  interface
    uses Graphics
        , u_c_shape_list
        ;

    TYPE c_rectangle_shape =
             Class(c_base_shape)
               m_width, m_height: Integer;

               Constructor create_rectangle_shape(p_x, p_y: Integer;
                   p_c_canvas_ref: tCanvas;
                   p_width, p_height: Integer);
               procedure draw_shape; Override;
               procedure resize(p_scale: Integer);
             end; // c_rectangle_shape

         c_ellipse_shape =
             Class(c_base_shape)
               m_radius: Integer;

               Constructor create_ellipse_shape(p_x, p_y: Integer;
                   p_c_canvas_ref: tCanvas;
                   p_radius: Integer);
               procedure draw_shape; Override;
             end; // c_ellipse_shape

  implementation

    // -- c_rectangle_shape

    Constructor c_rectangle_shape.create_rectangle_shape(p_x, p_y: Integer;
        p_c_canvas_ref: tCanvas;
        p_width, p_height: Integer);
      begin
        Inherited create_base_shape(p_x, p_y, p_c_canvas_ref);

        m_width:= p_width;
        m_height:= p_height;
      end; // create_rectangle_shape

    procedure c_rectangle_shape.draw_shape;
      begin
        m_c_canvas_ref.Rectangle(m_x, m_y, m_x+ m_width, m_y+ m_height);
      end; // draw_shape

    procedure c_rectangle_shape.resize(p_scale: Integer);
      begin
        m_width:= m_width* p_scale;
        m_height:= m_height* p_scale;
      end; // resize

    // -- c_ellipse_shape

    Constructor c_ellipse_shape.create_ellipse_shape( p_x,p_y: Integer;
        p_c_canvas_ref: tCanvas;
        p_radius: Integer);
      begin
        Inherited create_base_shape(p_x, p_y, p_c_canvas_ref);

        m_radius:= p_radius;
      end; // create_ellipse_shape

    procedure c_ellipse_shape.draw_shape;
      begin
        m_c_canvas_ref.ellipse(m_x- m_radius, m_y- m_radius,
            m_x+ m_radius, m_y+ m_radius);
      end; // draw_shape

  end.
