// 002 u_uml_class_diagram
// 02 mar 2009

// -- (C) John COLIBRI 2009
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_uml_class_diagram;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    width_edit_: TEdit;
    height_edit_: TEdit;
    radius_edit_: TEdit;
    resize_rectangles_: TButton;
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure resize_rectangles_Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
  uses u_c_shape_list, u_c_shapes;

{$R *.dfm}

    var g_c_shape_list: c_shape_list= Nil;

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        g_c_shape_list:= c_shape_list.create_shape_list;
      end; // FormCreate

    procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
        Shift: TShiftState; X, Y: Integer);
      begin
        if Button= mbLeft
          then g_c_shape_list.add_shape(
              c_rectangle_shape.create_rectangle_shape(X, Y, Canvas,
              StrToInt(width_edit_.Text), StrToInt(height_edit_.Text) ))
          else g_c_shape_list.add_shape(
              c_ellipse_shape.create_ellipse_shape(X, Y, Canvas,
              StrToInt(radius_edit_.Text )))
      end; // FormMouseDown

    procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
        Shift: TShiftState);
      begin
        case Key of
          vk_Left  : g_c_shape_list.move_shape(-5, 0);
          vk_Right : g_c_shape_list.move_shape(5, 0);
          vk_Up    : g_c_shape_list.move_shape(0, -5);
          vk_Down  : g_c_shape_list.move_shape(0, 5);
        end; // case Key
      end; // FormKeyDown

    procedure TForm1.FormPaint(Sender: TObject);
      begin
        g_c_shape_list.draw_shape_list;
      end; // FormPaint

    procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
      begin
        g_c_shape_list.Free;
      end; // FormClose

    procedure TForm1.resize_rectangles_Click(Sender: TObject);
      var l_shape_index: Integer;
      begin
        with g_c_shape_list do
          For l_shape_index:= 0 to m_shape_count-1 do
            if m_shape_array[l_shape_index] is c_rectangle_shape
              then c_rectangle_shape(m_shape_array[l_shape_index]).resize(2);
        Repaint;
      end; // resize_rectangles_Click

end.
